#include "androidapplicationcomponent.h"
#include "androidmanifestfile.h"
#include "builder.h"
#include "sourcepackage.h"

using namespace std;

AndroidManifestFile::AndroidManifestFile(Builder &b, const AndroidApplicationComponent &a):
	FileTarget(b, a.get_package(), a.get_package().get_temp_directory()/a.get_name()/"AndroidManifest.xml"),
	native_lib(0)
{
	component = &a;
	tool = &builder.get_toolchain().get_tool("AMG");

	add_dependency(package->get_build_file());
}

void AndroidManifestFile::set_native_library(SharedLibrary *lib)
{
	native_lib = lib;
}

void AndroidManifestFile::set_orientation(const string &ori)
{
	orientation = ori;
}

void AndroidManifestFile::add_permission(const string &perm)
{
	permissions.insert(perm);
}
