#ifndef BINARY_H_
#define BINARY_H_

#include "buildinfo.h"
#include "filetarget.h"

class Component;
class ObjectFile;

/**
Produces a binary file, which may be either a standalone executable or a shared
library.
*/
class Binary: public FileTarget
{
private:
	BuildInfo static_binfo;

protected:
	std::list<ObjectFile *> objects;

	Binary(Builder &, const Msp::FS::Path &);
	Binary(Builder &, const Component &, const std::string &, const std::list<ObjectFile *> &);

public:
	virtual void collect_build_info(BuildInfo &) const;

protected:
	virtual void find_dependencies();
};

#endif
