#include "builder.h"
#include "clangcompiler.h"
#include "clangtools.h"
#include "gnuarchiver.h"
#include "gnulinker.h"

using namespace std;

ClangTools::ClangTools(Builder &builder, const Architecture &arch)
{
	add_tool(new ClangCompiler(builder, arch, "CC"));
	add_tool(new ClangCompiler(builder, arch, "CXX"));
	add_tool(new ClangCompiler(builder, arch, "OBJC"));

	add_tool(new GnuLinker(builder, arch));
	add_tool(new GnuArchiver(builder, arch));
}
