#ifndef COPY_H_
#define COPY_H_

#include <msp/core/thread.h>
#include <msp/fs/path.h>
#include "internaltask.h"
#include "tool.h"

class InstalledFile;

/**
Copies a file to another place.  Used by the InstalledFile target.
*/
class Copy: public Tool
{
private:
	/**
	A worker thread that actually does the data transfer.
	*/
	class Worker: public InternalTask::Worker
	{
	private:
		const InstalledFile &target;

	public:
		Worker(const InstalledFile &);
	private:
		virtual void main();
	};

public:
	Copy(Builder &);

	virtual Target *create_target(const std::list<Target *> &, const std::string &);
	virtual Task *run(const Target &) const;
};

#endif
